<?php
namespace THM\DownloadExplorer\HelperClasses;
use JsonSerializable;

/**
 * Class ExtendedSplFileInfo
 *
 *
 */
class ExtendedSplFileInfo extends \SplFileInfo {

	/**
	 * Array with subfolder and files for current directory
	 *
	 * @var array
	 */
	protected $subFoldersAndFiles = array();

	/**
	 *
	 *
	 * @param array $subFoldersAndFiles
	 * @throws Exception\InvalidActionWithExtendedFileInfoException
	 */
	public function setSubFoldersAndFiles($subFoldersAndFiles) {
		if ($this->isFile()) {
			throw new Exception\InvalidActionWithExtendedFileInfoException('A file(non dir) object of type "THM\DownloadExplorer\HelperClasses\ExtendedSplFileInfo" has no sub folders and -files.', 1408610961);
		}
		$this->subFoldersAndFiles = $subFoldersAndFiles;
	}

	/**
	 *
	 *
	 * @throws Exception\InvalidActionWithExtendedFileInfoException
	 * @return array
	 */
	public function getSubFoldersAndFiles() {
		if ($this->isFile()) {
			throw new Exception\InvalidActionWithExtendedFileInfoException('A file(non dir) object of type "THM\DownloadExplorer\HelperClasses\ExtendedSplFileInfo" has no sub folders and -files.', 1408610959);
		}
		return $this->subFoldersAndFiles;
	}

	/**
	 * Adds file or folder to current directory.
	 *
	 * @param ExtendedSplFileInfo $subfolderOrFile
	 * @throws Exception\InvalidActionWithExtendedFileInfoException
	 */
	public function addSubFolderOrFile(ExtendedSplFileInfo $subfolderOrFile) {
		if ($this->isFile()) {
			throw new Exception\InvalidActionWithExtendedFileInfoException('Adding files and Folders to file(non dir) object of type "THM\DownloadExplorer\HelperClasses\ExtendedSplFileInfo" is not allowed.', 1408610622);
		}
		$this->subFoldersAndFiles[] = $subfolderOrFile;
	}

	/**
	 *
	 *
	 * @param ExtendedSplFileInfo $subfolderOrFile
	 * @throws Exception\InvalidActionWithExtendedFileInfoException
	 */
	public function removeSubFolderOrFile(ExtendedSplFileInfo $subfolderOrFile) {
		if ($this->isFile()) {
			throw new Exception\InvalidActionWithExtendedFileInfoException('Removing files or Folders from file(non dir) object object of type "THM\DownloadExplorer\HelperClasses\ExtendedSplFileInfo" is not allowed.', 1408610737);
		}
		// @todo use Extbases Container for $subFoldersAndFiles
	}

}