<?php
namespace THM\DownloadExplorer\ViewHelpers;

/**
 * A view helper to indicate whether a file has been added recently.
 */
class NewFileViewHelper extends \TYPO3\CMS\Fluid\Core\ViewHelper\AbstractViewHelper {

	/**
	 * Render a `<span>` to indicate that the file has been changed recently
	 *
	 * @param string $modifiedDate When was the file modified the last time?
	 * @param int $highlightForNHours How many hours after the file changed should it be highlighted?
	 * @return string `<span class="newFile">*</span>` when the file has changed recent. Else empty string.
	 */
	public function render($modifiedDate, $highlightForNHours) {
		$now = new \DateTime("now");
		$modified = new \DateTime();
		$modified->setTimeStamp($modifiedDate);
		$diff = $now->getTimestamp()-$modified->getTimestamp();
		$highlightForSeconds = $highlightForNHours * 3600;

		if($diff < $highlightForSeconds) {
			return '<span class="filetype newfile"></span>';
		} else {
			return '';
		}
	}
}
